from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({})
class SaveUserProviderLinkRequest(BaseModel):
    """SaveUserProviderLinkRequest

    :param user_provider_id: Unique identifier linking a user to the installed integration. Generated by the integration.
    :type user_provider_id: str
    :param user_id: Pipedrive user ID
    :type user_id: int
    :param company_id: Pipedrive company ID
    :type company_id: int
    :param marketplace_client_id: Pipedrive Marketplace client ID of the installed integration
    :type marketplace_client_id: str
    """

    def __init__(
        self,
        user_provider_id: str,
        user_id: int,
        company_id: int,
        marketplace_client_id: str,
    ):
        self.user_provider_id = user_provider_id
        self.user_id = user_id
        self.company_id = company_id
        self.marketplace_client_id = marketplace_client_id
